#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BANNER			"A Penguin Crackware Patch"
#define HEADER			"AtomTime98 version 2.54"
#define AUTHOR			"The Penguin 1998"
#define FILENAME 		"Atomtime.exe"

#define OPENTYPE 			"r+"
#define HI(x)			(x >> 8)
#define LO(x)			(x  & 0x00FF)
#define MAXBYTESPERCRACK 8
#define BYTE			unsigned char
#define ULONG			unsigned long


#define crkLen	3                

ULONG crkOfs[crkLen] = 
	{
	0x00004F5D,
	0x00004A36,
	0x000033A0
	};


ULONG crkTbl[crkLen][MAXBYTESPERCRACK] = 
{
	{2, 0x0F0F, 0x8485},
	{2, 0x0F0F, 0x8485},
	{2, 0x7574, 0x1818}	
};  
      
main(int argc, char *argv[])
{                      
	BYTE inbuf[MAXBYTESPERCRACK], inchar, bSame, patchbyte;
	FILE *fp;
	int bts, Ix, Jx;
	ULONG fOffset;
	long io_num;
	int  result, numread, dupchars, alreadpatched;
    
   
	printf("%s\n%s\n%s\n", BANNER, HEADER, AUTHOR);
	  
	
   	if( (fp = fopen( FILENAME, OPENTYPE )) == NULL )
   	{                                               
   		printf("Cannot open %s. Please move %s to the directory containing %s.  Exiting.\n", FILENAME, argv[0], FILENAME);
   		return(0);
	}	
                             
	
   	bSame = 1;
	alreadpatched = 0;
	for (Ix = 0; Ix < crkLen; Ix++)
	{
		
		fOffset = crkOfs[Ix];
		result = fseek( fp, fOffset, SEEK_SET);
		if( result )        
		{
			printf( "Error Seeking in File.(s)\n" );
			fclose(fp);
			return(0);
		}         
        
        
        bts = (int) crkTbl[Ix][0];
     	dupchars = 0;
     	numread = fread( inbuf, sizeof( char ), bts, fp);
        for (Jx = 0; Jx < bts; Jx++)
        {
        	inchar = inbuf[Jx];
    		patchbyte = (BYTE) HI(crkTbl[Ix][Jx+1]);
            
    		if (patchbyte != inchar) 
 			{
				if (inchar == ((BYTE) LO(crkTbl[Ix][Jx+1])))
					dupchars++;
					
				bSame = 0;
			}
        }
 	
 		if (bSame == 0) 
 		{
	 		if (dupchars == bts)
	 		{
	 			alreadpatched++;	
	 		}
		}
 	}                       

 	
	
 	if (!bSame)
	{
		if (((alreadpatched+1) == crkLen) || (alreadpatched == crkLen))
		    printf("Patch has already been applied.\n");
		else 
		    printf("Incorrect version\n");
		return(0);
	}
	                             
	
	for (Ix = 0; Ix < crkLen; Ix++)
	{
		
		fOffset = crkOfs[Ix];
		result = fseek( fp, fOffset, SEEK_SET	);
		if( result )        
		{
			printf( "Error Seeking in File.(s)\n" );
			fclose(fp);
			return(0);
		}         
        
        
        bts = (int) crkTbl[Ix][0];
        for (Jx = 0; (Jx < bts); Jx++)
        {
     		patchbyte = (BYTE) LO(crkTbl[Ix][Jx+1]);
    		io_num = fputc(patchbyte, fp );
        } 	
 	}


	
   	bSame = 1;
	for (Ix = 0; Ix < crkLen; Ix++)
	{
		
		fOffset = crkOfs[Ix];
		result = fseek( fp, fOffset, SEEK_SET);
		if( result )        
		{
			printf( "Error Seeking in File.(s)\n" );
			fclose(fp);
			return(0);
		}         
        
        
        bts = (int) crkTbl[Ix][0];
     	numread = fread( inbuf, sizeof( char ), bts, fp);
        for (Jx = 0; Jx < bts; Jx++)
        {
        	inchar = inbuf[Jx];
    		patchbyte = (BYTE) LO(crkTbl[Ix][Jx+1]);

    		if (patchbyte != inchar) 
 			{
				bSame = 0;
			}
        }
 	
 	}                       

 	
	
 	if (!bSame)
	{
		printf("File was not patched successfully (write protected?)\n");
		return(0);
	}

	
	printf( "AtomTime98 was patched Successfully. Have fun.\n" );

    
	
	fclose(fp);          

	
	return (1);	                                    
}


